#!/usr/bin/env python
# coding: utf-8

# ## Import Libraries

# In[135]:


import numpy as np
import pandas as pd


# ## Import Parameters

# In[136]:


params = np.loadtxt('_inpval.raw')
#params


# In[137]:


delta = float(params[0])
kerneltype = int(params[1])
m_start = int(params[2])
m_end = int(params[3])


# ## Import Data

# In[138]:


data = np.loadtxt('_data2.raw')
sort_data = np.sort(data)  #datos en orden acscendente
n = len(data)


# ## Initial Calc

# In[139]:


mnumber = m_end-m_start+1
maxval = sort_data[-1] #Máximo de los datos
minval = sort_data[0]  #Mínimo de los datos

if kerneltype == 6:
    delta=delta*4

start = minval - delta*(m_end+0.1)

origin = (np.floor(start/delta)-0.5)*delta
numbin = int(np.ceil((maxval+delta*(m_end+0.1)-origin)/delta)+1)
maxnoemp = min(n+1,numbin)

nl = 0
indexi = 0

bin_arr = np.zeros(int(numbin) + 1)
frequ = np.zeros(int(numbin) + 1)
index = np.zeros(int(numbin) + 1)

#print(n)
#print(origin)
#print(numbin)
#print(maxnoemp)


# ## Binning Data

# In[140]:


for i in range(0,n):
    indexi = int((sort_data[i]-origin)/delta);
    #print(indexi)
    if (bin_arr[indexi]==0):
        nl = nl + 1;
        frequ[nl] = 1;
        index[nl] = indexi;
        bin_arr[indexi] = nl;
        
    else:
        frequ[int(bin_arr[indexi])] = frequ[int(bin_arr[indexi])]+1


# In[141]:


index = index.astype(int)


# ## Main Loop

# In[142]:


fm = np.zeros(int(numbin)+3)
C = []
Mv = []
B = []
ma = np.zeros(9)

for M in range(m_start,m_end+1): #loop corregido
    ma[1] = M
    #print(ma[1])
    for im in range(2,9):
        ma[im] = ma[1]**im
        #print(ma[im])
    h = M*delta
    score=0
    
#    intsquare = 0
#    estexp=0
    for z in range(0,int(numbin)+1): #loop corregido
        fm[z]=0;
           
    #Kernelcases
    kwe = np.zeros(M)
    
    #CalcFunctional
    #Case 1
    if kerneltype == 1:
        tau = (16 * ma[4] + 32 * ma[2] - 13) / (112 * ma[2] + 28)
        divisor = (16 * ma[4] - 1) * (4 * ma[2] + 1)
        kappa = 15 * ma[1] / 7 * (1 - (32 * ma[4] - 28 * ma[2] + 1) / divisor)
        zeta = 30 / 7 * (336 * ma[3] - 420 * ma[2] + 85 * ma[1] + 104) / divisor
        

    #Case 2
    if kerneltype == 2:
        tau = (32 * ma[6] + 80 * ma[4] + 62 * ma[2] - 69) / (288 * ma[4] + 72 * ma[2] + 60)
        divisor = (4 * ma[2] - 1) * (24 * ma[4] + 6 * ma[2] + 5) ** 2
        kappa = 350 * ma[1] / 143 * (1 - (4492.8 * ma[8] - 979.2 * ma[6] + 2124 * ma[4] - 866.4 * ma[2] - 2755.2) / (3 * divisor))
        zeta = 630 * (128 * ma[7] - 448 * ma[5] + 560 * ma[4] - 280 * ma[3] - 280 * ma[2] + 320 * ma[1] + 35) / divisor
       
    #CreateWeights
        
        
    #Case 1
    if kerneltype == 1:
        cm =0.9375/((1-0.0625/(M**4))*(n*h));
        for l in range (0,M):               #loop corregido
            kwe[l] = cm*((1-((l/M)**2))**2)
    #Case 2
    if kerneltype == 2:
        part1 = 1+0.14583333/(M**4)
        part2 = 0.052083333/(M**6)
        cm = 1.09375/((part1-part2)*(n*h))
        for l in range(0,M):               #loop corregido
            kwe[l] = cm*((1-((l/M)**2))**3);
    
    ###
    #KW LS Z Weightbins
    ####

    for kw in range(1,nl+1):            #loop corregido
        for lw in range(1-M,M):          #loop corregido
            if index[kw] + lw > 0:
                fm[index[kw]+lw] = fm[index[kw]+lw]+kwe[abs(lw)]*frequ[kw]
   
    #MainLoop
    
    for z in range(1,numbin):
        score=score + (fm[z+1]-2*fm[z]+fm[z-1])**2
    score=score + (fm[numbin-1]-fm[numbin-2])**2
    score=score + (2*fm[0]-fm[1])**2
    score=score + fm[0]**2 + fm[numbin-1]**2
    score=score * delta * 0.25
    score=score-zeta/(4*n*ma[2]*delta)
    score=score*tau**2+1/180
    bcv=np.zeros(M-m_start+2) #Inicializa bcv
    bcv[M-m_start+1] = score+kappa/(3*n*ma[2]*delta)
    mv=np.zeros(M-m_start+2) #Inicializa mv
    mv[M-m_start+1]= M
    hv=np.zeros(M-m_start+2) #Inicializa hv
    hv[M-m_start+1]=mv[M-m_start+1]*delta
   
    
    #print(bcv[-1])    
    C.append(bcv[-1])
    Mv.append(mv[-1])
    B.append(hv[-1])


# ## Data output 

# In[143]:


pd.set_option("display.precision", 10) #Número de decimales a mostrar

resArr = pd.DataFrame(np.array([C,Mv,B]).transpose(), #Acomoda los datos en un DataFrame
            columns = ['BCV','M','B']) 
 
#resArr = resArr.sort_values('CV') #Ordena los datos en orden ascendente de acuerdo con la columna 'CV'


# In[144]:


resArr.to_csv('./resfile.csv')

