#!/usr/bin/env python
# coding: utf-8

# # Importando librerías

# In[89]:


import numpy as np
import pandas as pd


# # Parámetros

# In[90]:


#delta = .05
#selector = 2 
#kerneltype = 4
#m_start = 5
#m_end = 40
#boundary = 0.1
params = np.loadtxt('_inpval.raw')
delta = params[0]
selector = int(params[1])
kerneltype = int(params[2])
m_start = int(params[3])
m_end = int(params[4])
boundary = params[5]
#print(delta)
#print(selector)
#print(kerneltype)
#print(m_start)
#print(m_end)
#print(boundary)


# In[91]:


def SelecFun(u,v,selector):
        Selec=0
        if selector == 1:
            Selec = 1+2*(u/v)
        if selector == 2:
            Selec = 1/(1-u/v)**2
        if selector == 3:
            Selec = np.exp(2*u/v)
        if selector == 4:
            Selec = (1.0 +u/v) / (1.0-u/v)
        if selector == 5:
            Selec = 1.0/(1.0 - 2.0*u/v)
        return(Selec)
    


# In[92]:


def InputValues():
    data = np.loadtxt('_data2.raw') # lee los datos
    
    # COlumna Y
    X = [data[elem][0] for elem in range(0,len(data))]
    
    #Columna X 
    Y = [data[elem][1] for elem in range(0,len(data))]
    
    #Y = data[0]
    #X = data[1]
    
    data = np.array([X,Y])
    return(data)

#print(Y)
#print(X)


# In[93]:


data = InputValues()
X = data[0]
Y = data[1]
n = len(X)
#print(X)
#print(Y)
#print(n)


# In[94]:


#X=np.sort(X)
mnumber = m_end - m_start + 1
maxval = X[-1];
minval = X[0];

#print(maxval)
#print(minval)

if kerneltype == 6:
    delta = 4*delta

start = minval - delta*(m_end+0.1)
    
#if start < 0:
origin = (np.floor(start/delta)-0.5)*delta
#    origin = (round((start/delta)-0.5)-0.5) * delta
#else:
#    origin = (int(start/delta)-0.5)*delta
numbin = int(np.ceil((maxval+delta*(m_end+0.1)-origin)/delta)+1)    
#numbin = int(round(((maxval+delta*(m_end+0.1)-origin)/delta)+0.5)+1)
    
binboundl = int(((X[int(n*boundary/2)])-origin)/delta)
    
binboundh = int(((X[int(n-n*boundary/2)])-origin)/delta)
    
if n+1 < numbin:
    maxnoemp = n+1
else:
    maxnoemp = numbin

nl = 0
nlweight = 0
    
    #Arreglos con ceros:
bin_arr = np.zeros(numbin+1)
counts1 = np.zeros(numbin+1)
yesum = np.zeros(numbin+1)
ysquaresum = np.zeros(numbin+1)
kwe1 = np.zeros(numbin+1,dtype=int)
indexa = np.zeros(numbin+1)

#print(selector)
#print(kerneltype)
#print(n)
#print(start)
#print(maxval)
#print(delta)
#print(origin)
#print(numbin)
#print(maxnoemp)


#  ### BINNING DATA

# In[95]:


indexweight = np.zeros(n+1)
    
nl = 0
nlweight=0
    
for ib in range(0,n):
    j = int((X[ib]-origin)/delta)

    if bin_arr[j]==0:
        nl = nl+1;
        counts1[nl] = 1;
        yesum[nl] = Y[ib]
        ysquaresum[nl] = Y[ib]**2;
        indexa[nl] = j
        bin_arr[j] = nl
        if (j>=binboundl) and (j<=binboundh):
            nlweight = nlweight+1
            indexweight[nlweight] = nl
    else:
        counts1[int(bin_arr[j])] = counts1[int(bin_arr[j])]+1;
        yesum[int(bin_arr[j])] = yesum[int(bin_arr[j])]+Y[ib];
        ysquaresum[int(bin_arr[j])] = ysquaresum[int(bin_arr[j])]+Y[ib]**2

#print(ib)
#print(j)
#print(yesum)
#print(ysquaresum)
#print(len(yesum))


# In[96]:


indexa = indexa.astype(int)


# # Defining M

# In[97]:


rm1 = 0
fmr = 0
mm1 = 0

#km = np.zeros(nlweight,dtype=int)
mv1 = np.zeros(m_end-m_start+1)
hv1 = np.zeros(m_end-m_start+1)


# ## Main Loop

# In[98]:


#C=[]
#M=[]
#H=[]
score1 = np.zeros(m_end-m_start+1)
for M in range(m_start,m_end+1):
    
    if kerneltype == 1:
        kwel = [1 for l in range(0,M)]

    if kerneltype == 2:
        kwel = [1 - (l/M) for l in range(0,M)]

    if kerneltype == 3:
        kwel = [1 - (l/M)**2 for l in range(0,M)]

    if kerneltype == 4:
        kwel = [(1 - (l/M)**2)**2 for l in range(0,M)]

    if kerneltype == 5:
        kwel = [(1 - (l/M)**2)**3 for l in range(0,M)]

    if kerneltype == 6:
        kwel = [np.exp(-8.0*(l/M)**2) for l in range(0,M)]
        
    for jm in range(1,nlweight+1):
        km = indexweight[jm]
   
        for im in range(1-M,M):
            index2 = bin_arr[int(indexa[int(km)]+im)]
            if index2>0:
                #print(abs(im))
                rm1 = rm1 + kwel[abs(im)] * yesum[int(index2)]
                #print(abs(im))
                fmr = fmr + kwel[abs(im)] * counts1[int(index2)]
                
        mm1 = rm1/fmr
        term1 = ysquaresum[int(km)]-2*mm1*yesum[int(km)]+counts1[int(km)]*mm1**2;
        term2 = SelecFun(kwel[0],fmr,selector) 
        score1[M - m_start] = score1[M-m_start]+term1*term2    
        
        rm1 = 0
        fmr = 0

    mv1[M-m_start] = M           
    hv1[M-m_start] = mv1[M-m_start]*delta
    score1[M-m_start] = score1[M-m_start]/n
    #C.append(score1[-1])
    #M.append(mv1[-1])
    #H.append(hv1[-1])
    


# ## Output

# In[99]:


pd.set_option("display.precision", 10)
#print(score1)
#print(n)
#print(mv1)
#print(hv1)
resArr = pd.DataFrame(np.array([score1,mv1,hv1]).transpose(), #Acomoda los datos en un DataFrame
            columns = ['C','M','H'])
resArr.to_csv('./resfile.csv')


# In[ ]:





# In[ ]:





# In[ ]:




