#!/usr/bin/env python
# coding: utf-8

# ## Import Libraries

# In[38]:


import numpy as np
import pandas as pd


# ## Import Parameters

# In[39]:


params = np.loadtxt('_inpval.raw')
#params


# In[40]:


delta = float(params[0])
kerneltype = int(params[1])
m_start = int(params[2])
m_end = int(params[3])


# ## Import Data

# In[41]:


data = np.loadtxt('_data2.raw')
sort_data = np.sort(data)  #datos en orden acscendente
n = len(data)


# ## Initial Calc

# In[42]:


mnumber = m_end-m_start+1
maxval = sort_data[-1] #Máximo de los datos
minval = sort_data[0]  #Mínimo de los datos

if kerneltype == 6:
    delta=delta*4

start = minval - delta*(m_end+0.1)

origin = (np.floor(start/delta)-0.5)*delta
numbin = int(np.ceil((maxval+delta*(m_end+0.1)-origin)/delta)+1)
maxnoemp = min(n+1,numbin)

nl = 0
indexi = 0

bin_arr = np.zeros(int(numbin) + 1)
frequ = np.zeros(int(numbin) + 1)
index = np.zeros(int(numbin) + 1)

#print(n)
#print(origin)
#print(numbin)
#print(maxnoemp)


# ## Binning Data

# In[43]:


for i in range(0,n):          #loop corregido
    indexi = int((sort_data[i]-origin)/delta);
    #print(indexi)
    if (bin_arr[indexi]==0):
        nl = nl + 1;
        frequ[nl] = 1;
        index[nl] = indexi;
        bin_arr[indexi] = nl;
        
    else:
        frequ[int(bin_arr[indexi])] = frequ[int(bin_arr[indexi])]+1


# In[44]:


index = index.astype(int)


# # Defining M

# In[45]:


fm = np.zeros(int(numbin)+3)
for M in range(m_start,m_end+1):
    h = M*delta
    intsquare = 0
    estexp=0
    for z in range(1,int(numbin)):
        fm[z]=0;
        #CreateWeight();
        #WeightBins();


# ## kernel Cases

# In[46]:


kwe = np.zeros(M)


# In[47]:


for kw in range(0,nl-1):
    for lw in range(1-M,M-1):
        if index[kw] + lw > 0:
            fm[int(index[kw]+lw)] = fm[int(index[kw]+lw)]+kwe[abs(lw)]*frequ[kw]

for kl in range(1,nl):
    #print(index[kl])
    estexp = estexp + frequ[kl]*fm[index[kl]]
estexp = estexp-(kwe[0]*n)
estexp = estexp/(n-1)

for z in range(1,int(numbin)):
    intsquare = intsquare + (fm[z]**2);
intsquare = intsquare*delta

cv=np.zeros(M-m_start+2)
cv[M-m_start+1] = intsquare-2*estexp

mv=np.zeros(M-m_start+2)
mv[M-m_start+1] = M

hv=np.zeros(M-m_start+2)
if kerneltype == 6:
    hv[M-m_start+1] = mv[M-m_start+1]*delta/4
else:
    hv[M-m_start+1] = mv[M-m_start+1]*delta


# ## Main Loop

# In[48]:


fm = np.zeros(int(numbin)+3)
C = []
Mv = []
B = []
for M in range(m_start,m_end+1): #loop corregido
    h = M*delta
    intsquare = 0
    estexp=0
    for z in range(1,int(numbin)+1):  #loop corregido
        fm[z]=0;
    
    #Kernelcases
    kwe = np.zeros(M)
    #Case 1
    if kerneltype == 1:
        cm = M/((2*M-1)*(n*h))
        for l in range (0,M):      #loop corregido
            kwe[l]= cm
    #Case 2
    if kerneltype == 2:
        cm =1/(n*h)
        for l in range (0,M):        #loop corregido
            kwe[l] = cm*(1 -(l/M))
    #Case 3
    if kerneltype == 3:
        cm =3*(M**2)/((4*(M**2)-1)*(n*h))
        for l in range (0,M):        #loop corregido
            kwe[l]= cm*(1-(l/M)**2);
    #Case4
    if kerneltype == 4:
        cm =0.9375/((1-0.0625/(M**4))*(n*h));
        for l in range (0,M):                  #loop corregido
            kwe[l] = cm*((1-((l/M)**2))**2)
    #Case5
    if kerneltype == 5:
        part1 = 1+0.14583333/(M**4)
        part2 = 0.052083333/(M**6)
        cm = 1.09375/((part1-part2)*(n*h))
        for l in range(0,M):                   #loop corregido
            kwe[l] = cm*((1-((l/M)**2))**3);
    #Case6
    if kerneltype == 6:
        cm = 0.3989*4/(n*h);
        for l in range(0,M):                    #loop corregido
            kwe[l] =cm * np.exp(-8.0*((l/M)**2))
    
    ###
    #KW LS Z
    ####
    for kw in range(0,nl):          #loop corregido
        for lw in range(1-M,M):     #loop corregido
            if index[kw] + lw > 0:
                fm[index[kw]+lw] = fm[index[kw]+lw]+kwe[abs(lw)]*frequ[kw]

    for kl in range(1,nl+1):  #loop corregido
    #print(index[kl])
        estexp = estexp + frequ[kl] * fm[index[kl]]
    estexp = estexp-(kwe[0]*n)
    estexp = estexp/(n-1)

    for z in range(1,numbin):
        intsquare = intsquare + (fm[z]**2);
    intsquare = intsquare*delta

    cv=np.zeros(M-m_start+2) #Inicializa cv
    cv[M-m_start+1] = intsquare -2 *estexp

    mv=np.zeros(M-m_start+2) #Inicializa mv
    mv[M-m_start+1] = M

    hv=np.zeros(M-m_start+2)
    if kerneltype == 6:
        hv[M-m_start+1] = mv[M-m_start+1]*delta/4
    else:
        hv[M-m_start+1] = mv[M-m_start+1]*delta 
    #print(cv[-1])    
    C.append(cv[-1])
    Mv.append(mv[-1])
    B.append(hv[-1])


# ## Data output 

# In[49]:


pd.set_option("display.precision", 10) #Número de decimales a mostrar

resArr = pd.DataFrame(np.array([C,Mv,B]).transpose(), #Acomoda los datos en un DataFrame
            columns = ['CV','M','B']) 
 
#resArr = resArr.sort_values('CV') #Ordena los datos en orden ascendente de acuerdo con la columna 'CV'


# In[50]:


resArr.to_csv('./resfile.csv')

