#!/usr/bin/env python
# coding: utf-8

# In[28]:


import numpy as np
import pandas as pd


# # Import Data

# In[29]:


data = np.loadtxt('_data2.raw')
n = len(data)


# In[30]:


X = [data[i][0] for i in range(0,n)]


# In[31]:


Y = [data[i][1] for i in range(0,n)]


# # Model Parameters

# In[32]:


params = np.loadtxt('_inpval.raw')
h = float(params[0])
M = int(params[1])
kernel_type = int(params[2])


# # Initial Calc (revisado)

# In[33]:


maxval = X[-1];
minval = X[0];

if kernel_type == 6:
    h = 4*h

delta = h/M
start = minval-h-delta*0.1

if start<0:
    origin = (round((start/delta)-0.5)-0.5)*delta
else:
    origin = (int(start/delta)-0.5)*delta
    
numbin = int(((maxval+h+delta*0.1-origin)/delta)+0.5)+1

if n+1 < numbin:
    maxnoemp = n+1

else:
    maxnoemp = numbin

indexstart = int((minval-origin)/delta)
indexend = int((maxval-origin)/delta)

midval = [origin+((0.5+ia)*delta) for ia in range(indexstart, indexend+1)]

nl = 0
j = 0

binar = np.zeros(numbin+1)
frequ = np.zeros(numbin+1)
index = np.zeros(numbin+1)
ysum = np.zeros(numbin+1)


# # Binning Data

# In[35]:


for i in range(0,n):
       j = int((X[i]-origin)/delta)
       if binar[j] == 0:
           nl = nl + 1
           index[nl] = j
           frequ[nl] = 1
           ysum[nl] = Y[i]
           binar[j] = nl
       else:
           frequ[int(binar[j])]=frequ[int(binar[j])]+1
           ysum[int(binar[j])]=ysum[int(binar[j])]+Y[i]


# # Create Weight

# In[21]:


if kernel_type == 1: 
    kwe = [1 for l in range(0,M)]

if kernel_type == 2: 
    kwe = [1 -l/M for l in range(0,M)]

if kernel_type == 3:
    kwe = [1-((l/M)**2) for l in range(0,M)]

if kernel_type == 4:
    kwe = [(1-(l/M)**2)**2 for l in range(0,M)]
    
if kernel_type == 5:
    kwe = [(1-(l/M)**2)**3 for l in range(0,M)]

#Al cuadrado o raíz?
if kernel_type == 6:
    kwe = [np.exp(-8*((l/M)**2)) for l in range(0,M)]
    


# # WeightBins

# In[22]:


fm = np.zeros(numbin)
rm = np.zeros(numbin)

for kw in range(1, nl+1):
    for lw in range(1-M,M):
        indexi = int(lw+index[kw])
        lwabs = abs(lw)
        fm[indexi] = fm[indexi]+kwe[lwabs]*frequ[kw]
        rm[indexi] = rm[indexi]+kwe[lwabs]*ysum[kw]


# # CombiNumDen

# In[23]:


mm = np.zeros(numbin)


# In[24]:


for j in range(0, numbin-1):
    if fm[j] == 0:
        mm[j] = 0
    else:
        mm[j]=rm[j]/fm[j]


# # Result File

# In[25]:


midval = np.array(midval)


# In[26]:


pd.set_option("display.precision", 10) #Número de decimales a mostrar
result_df = pd.DataFrame([mm[indexstart:indexend+1],midval]).transpose()
result_df.columns = ['mm','midval']
#result_df
result_df.to_csv('./resfile.csv')

